#!/bin/sh

""":"
exec python $0 ${1+"$@"}
"""

# this script transforms input.sdf (the original) to reference.sdf
# sdf -2html reference.sdf
#   produces an html file, do these changes:
#   BGCOLOR="white", remove date
# sdf -2man reference.sdf > reference.n
# nroff -man reference.n | less

import re, string

f = open( "input.sdf", "r" )
lines = f.readlines()

out = open( "reference.sdf", "w" )
out.write("""
!init   OPT_STYLE="manual"
!define DOC_NAME "A complete reference to the Pmw.Blt plot widget"
!define DOC_TOC      2
!build_title
""")
for line in lines:
    line = re.sub( ">>Title:: ",      "H1: ",               line )
    line = re.sub( ">>Purpose::",     "H1: Purpose\n\n",   line )
    if re.search ( ">>Synopsis::", line):
        parts = re.split("::", line)
        line = "P4: Synopsis\n\n{{EX:%s}}\n" % parts[1][:-1]  # remove \n
    if re.search ( ">>See_also::", line):
        parts1 = re.split("::", line)
        parts2 = re.split(",",string.strip(parts1[1]))
        line = "P4: See also\n\n"
        for part in parts2:
            part = string.strip(part)
            if re.search(r"\.py$", part):  # python script
                python_listing = re.sub(r"\.py$",".html",part)
                line = line + '{{[jump="python/html/%s"]%s}},\n' % (python_listing,part)
            else:  # another function in this reference
                line = line + '{{SECT:%s}},\n' % part
        line = line[:-2] + "\n"  # remove , before last \n

    if re.search(r"^\* .*:", line):
        line = "* {{EX[color=\"red\"]%s}}\n  {{CHAR:nl}}\n" % line[2:-2]
        
    line = re.sub( ">>Description::", "P4: Description\n", line )
    out.write( line )
    
f.close()
out.close()

    
    
    
