C----------------------------------------------------------------------
C Calculates the exponential voltage for a given time t
C----------------------------------------------------------------------
      function expnt(time, freq, n, ampl, phase, decay, t0, tend)
      IMPLICIT NONE
      Integer n
      double precision expnt, time, freq(n), ampl(n), phase(n), 
     1                  decay(n),  t0(n), tend(n)


      Integer i, testc
      double precision alpha, mydec, calct, tmp1
      
      expnt = 0.0D0
      testc = 0
      DO 400, i = 1,n
         if (time .gt. t0(i) .and. time .lt. tend(i)) then
            calct = time - t0(i)
            tmp1  = calct * freq(i)
            alpha = ampl(i) * dsin(tmp1  + phase(i))
            mydec = alpha   * dexp(calct * decay(i))
            expnt = expnt + mydec
            testc = testc + 1
         endif
 400  CONTINUE
      END

C------------------------------------------------------------------------------
C Calculates expnt for each time(i)
C------------------------------------------------------------------------------
      subroutine expnta(volts, m, time, freq, n, ampl, phase, 
     1                  decay, t0, tend)
      IMPLICIT NONE
      Integer m, n
      double precision expnt, time(m), freq(n), ampl(n), phase(n), 
     1                  decay(n),  t0(n), tend(n), volts(m)


      Integer i

      DO 500, i = 1,m
         volts(i) = expnt(time(i), freq, n, ampl, phase, decay, 
     1                    t0, tend)
 500  CONTINUE
      END
