class lahey_fortran_compiler(fortran_compiler_base):
    vendor = 'Lahey/Fujitsu'
    ver_match = r'Lahey/Fujitsu Fortran 95 Compiler Release(?P<version>[^\s*]*)'
    
    def __init__(self, fc = None, f90c = None):
        fortran_compiler_base.__init__(self)

        if fc is None:
            fc = 'lf95'
        if f90c is None:
            f90c = fc

        self.f77_compiler = fc
        self.f90_compiler = f90c

        switches = ''
        debug = ' -g --chk --chkglobal '

        self.f77_switches = self.f90_switches = switches
        self.f77_switches = self.f77_switches + ' --fix '
        self.f77_debug = self.f90_debug = debug
        self.f77_opt = self.f90_opt = self.get_opt()

        self.ver_cmd = self.f77_compiler+' --version'
        try:
            dir = os.environ['LAHEY'] 
            self.library_dirs = [os.path.join(dir,'lib')]
        except KeyError:
            self.library_dirs = []

        self.libraries = ['fj9f6', 'fj9i6', 'fj9ipp', 'fj9e6']


    def get_opt(self):
        opt = ' -O'
        return opt

    def get_linker_so(self):
        return [self.f77_compiler ,'--shared']
