#!/usr/bin/env python
import Numeric
import _lsodarsimple

def lsodar(f, y, t, tout,  *args, **keywords):
    """
    Wrapper around lsodar from ODEPACK
    """
    
    itol = 1;  rtol = 1e-6;    atol = 1e-6
    task = 1;  state = 1;
    jac = None;    jt = 2
    if keywords.has_key('border'):
        border = keywords['border']
        tmp = border(t,y)
        if type(tmp) != type(Numeric.array((0,0))):
            raise TypeError, "The border function must return an array!"
        
        ng = len(tmp)
        assert(ng != None)
        assert(ng > 0)
    else:
        border = lambda x:x
        ng = 0
    if keywords.has_key('jacobi'):
        jacobi = keywords['jacobi']
    else:
        jacobi = lambda x:x

    assert(itol == 1 or itol == 2) 
    y,t,state,jroot = _lsodarsimple.lsodar(f, y, t, tout, itol, rtol, atol,
                                           task, state, jacobi, jt,
                                           border, ng)
    return y, t, state, jroot
