#define FAILURE  0
#define SUCCESS  1
#include <Python.h>
#include "foo.h"

int bar(int var, int * r, void * unused)
{
     *r =  var * 2.0;
     return SUCCESS;
}

int py_bar(int var, int * r, void * args)
{
     PyObject *arglist = NULL;
     PyObject *result = NULL;
     foo_callback *p = NULL;
     int flag = SUCCESS;

     p = (foo_callback *) args;

     arglist = Py_BuildValue("(iO)", var, p->args);

     result = PyEval_CallObject(p->callback, arglist);
     Py_DECREF(arglist);
     if(! result){
	  PyErr_SetString(PyExc_ValueError, "exception in python function.");
	  flag = FAILURE;
     }
     if(! PyArg_Parse(result, "i", r)){
	  PyErr_SetString(PyExc_ValueError, 
			  "non-Integer result form python function.");
	  flag = FAILURE;
     }
     Py_XDECREF(result);


     return flag;

}


int foo(int (*callback)(int, int*, void * args), int var, int *r, void *args)
{
     int tmp;
     return callback(var, r, args);
}

